include "strtools.sol"


void usage()
  print "Word Numbers - Freeware (c) 2002 by D.G. Sureau"
  print "Free BSD Licence - www.freepgrogrammer.com"
  print "Making a list of words from a text file"
  print "count occurences, put them and sort by number"
  print "Syntax:  wordnum textfile wordfile"
  exit()
return


int main (int argnum, array arg)
  file inPtr
  file outPtr
  text inName
  text outName

  text line
  dict words = ()

  print
  if argnum != 3 ?  usage()

  inName  = arg[1]
  outName = arg[2]

  print "Reading", inName, "writing into", outName

  StrTools str

  inPtr.open(inName, "rt")
  error ? die("Cannot open " + inName)

  outPtr.open(outName,"wb")
  error ? die("Cannot open " + outName)

  int linenum = 0
  print "working... "
  while not inPtr.eof()
    line = inPtr.readLine()
    array lwords = str.split(line, " \t\r\n ,;?!.-\"\'(){}+*/%=)]@~#&|[]:<>")
    for text w in lwords
     w = w.trim().lower()
     if words[w] = nil
        words[w] = 1
     else
        words[w] = words[w].toInt() + 1
     /if
    /for
    linenum + 1
  /while



  inPtr.close()

  words.sort()
  for text k, text v in words
    outPtr.write(k + ":" + v.toText() + "\n")
  /for
  outPtr.close()

  print linenum, "lines read from ", inName
  print words.size(), "words written into", outName

return 0


main($argc, $argv)
